Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:49 2008
FILE NAME: i.lpj_kill.f90
PROGRAM NAME: lpj_kill
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    37  obsol(  18): CHARACTER* form of character declaration is used.
    86  vec  (   3): Unvectorized loop.
    86  vec  (  13): Overhead of loop division is too large.
    88  vec  (   4): Vectorized array expression.
    98  vec  (   4): Vectorized array expression.
   106  opt  (1084): Branch out of the loop inhibits optimization.
   106  vec  (   4): Vectorized array expression.
   106  vec  (  26): Macro operation Search.
   108  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   166  vec  (  17): Unvectorizable statement.
   167  vec  (  17): Unvectorizable statement.
   167  vec  (  18): Unvectorizable data type.
   167  vec  (   4): Vectorized array expression.
   179  warn (  83): Dummy argument "lai" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:49 2008
FILE NAME: i.lpj_kill.f90
PROGRAM NAME: lpj_kill
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! kills pfts that obviously fare badly
     2:            !
     3:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/lpj_kill.f90,v 1.7 2007/05/28 14:49:02 ssipsl Exp $
     4:            ! IPSL (2006)
     5:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     6:            !
     7:            MODULE lpj_kill
     8:            
     9:              ! modules used:
    10:            
    11:              USE ioipsl
    12:              USE stomate_constants
    13:            
    14:              IMPLICIT NONE
    15:            
    16:              ! private & public routines
    17:            
    18:              PRIVATE
    19:              PUBLIC kill
    20:            
    21:            CONTAINS
    22:            
    23:              SUBROUTINE kill (npts, whichroutine, lm_lastyearmax, &
    24:                               ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
    25:                               lai, age, leaf_age, leaf_frac, &
    26:                               when_growthinit, everywhere, veget, veget_max, bm_to_litter)
    27:            
    28:                !
    29:                ! 0 declarations
    30:                !
    31:            
    32:                ! 0.1 input
    33:            
    34:                ! Domain size
    35:                INTEGER(i_std), INTENT(in)                                       :: npts
    36:                ! message
    37:                CHARACTER*10, INTENT(in)                                  :: whichroutine
    38:                ! last year's maximum leaf mass, for each PFT (gC/(m**2 of nat/agri ground))
    39:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: lm_lastyearmax
    40:            
    41:                ! 0.2 modified fields
    42:            
    43:                ! Number of individuals / m**2
    44:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: ind
    45:                ! Is pft there
    46:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)              :: PFTpresent
    47:                ! crown area of individuals (m**2)
    48:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: cn_ind
    49:                ! biomass (gC/(m**2 of nat/agri ground))
    50:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)    :: biomass
    51:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
    52:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)              :: senescence
    53:                ! How much time ago was the PFT eliminated for the last time (y)
    54:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: RIP_time
    55:                ! leaf area index OF AN INDIVIDUAL PLANT
    56:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)           :: lai
    57:                ! mean age (years)
    58:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: age
    59:                ! leaf age (days)
    60:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout) :: leaf_age
    61:                ! fraction of leaves in leaf age class
    62:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout) :: leaf_frac
    63:                ! how many days ago was the beginning of the growing season
    64:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: when_growthinit
    65:                ! is the PFT everywhere in the grid box or very localized (after its introduction)
    66:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: everywhere
    67:                ! fractional coverage on natural/agricultural ground, taking into
    68:                !   account LAI (=grid-scale fpc)
    69:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: veget
    70:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    71:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: veget_max
    72:                ! conversion of biomass to litter (gC/(m**2 of nat/agri ground)) / day
    73:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)    :: bm_to_litter
    74:            
    75:                ! 0.3 local
    76:            
    77:                ! indices
    78:                INTEGER(i_std)                                             :: j,m
    79:                ! bookkeeping
    80:                LOGICAL, DIMENSION(npts)                                  :: was_killed
    81:            
    82:                ! =========================================================================
    83:            
    84:                IF (bavard.GE.3) WRITE(numout,*) 'Entering kill'
    85:            
    86: +------>       DO j = 1, npft
    87: |          
    88: |V=====          was_killed(:) = .FALSE.
    89: |          
    90: |                ! only kill natural PFTs
    91: |          
    92: |                IF ( natural(j) ) THEN
    93: |          
    94: |                  ! kill present plants if number of individuals or last year's leaf
    95: |                  ! mass is close to zero.
    96: |                  ! the "was_killed" business is necessary for a more efficient code on the VPP
    97: |          
    98: |V----->           WHERE ( PFTpresent(:,j) .AND. &
    99: ||                         ( ( ind(:,j) .LT. min_stomate ) .OR. &
   100: ||                         ( lm_lastyearmax(:,j) .LT. min_stomate ) ) )
   101: ||         
   102: |V-----              was_killed(:) = .TRUE.
   103: |          
   104: |                  ENDWHERE
   105: |          
   106: |V=====            IF ( ANY( was_killed(:) ) ) THEN
   107: |          
   108: |V----->             WHERE ( was_killed(:) )
   109: ||         
   110: ||                     ind(:,j) = 0.0
   111: ||           
   112: ||                     bm_to_litter(:,j,ileaf) = bm_to_litter(:,j,ileaf) + biomass(:,j,ileaf)
   113: ||                     bm_to_litter(:,j,isapabove) = bm_to_litter(:,j,isapabove) + biomass(:,j,isapabove)
   114: ||                     bm_to_litter(:,j,isapbelow) = bm_to_litter(:,j,isapbelow) + biomass(:,j,isapbelow)
   115: ||                     bm_to_litter(:,j,iheartabove) = bm_to_litter(:,j,iheartabove) + &
   116: ||                                                     biomass(:,j,iheartabove)
   117: ||                     bm_to_litter(:,j,iheartbelow) = bm_to_litter(:,j,iheartbelow) + &
   118: ||                                                     biomass(:,j,iheartbelow)
   119: ||                     bm_to_litter(:,j,iroot) = bm_to_litter(:,j,iroot) + biomass(:,j,iroot)
   120: ||                     bm_to_litter(:,j,ifruit) = bm_to_litter(:,j,ifruit) + biomass(:,j,ifruit)
   121: ||                     bm_to_litter(:,j,icarbres) = bm_to_litter(:,j,icarbres) + biomass(:,j,icarbres)
   122: ||           
   123: ||                     biomass(:,j,ileaf) = 0.0
   124: ||                     biomass(:,j,isapabove) = 0.0
   125: ||                     biomass(:,j,isapbelow) = 0.0
   126: ||                     biomass(:,j,iheartabove) = 0.0
   127: ||                     biomass(:,j,iheartbelow) = 0.0
   128: ||                     biomass(:,j,iroot) = 0.0
   129: ||                     biomass(:,j,ifruit) = 0.0
   130: ||                     biomass(:,j,icarbres) = 0.0
   131: ||           
   132: ||                     PFTpresent(:,j) = .FALSE.
   133: ||           
   134: ||                     cn_ind(:,j) = 0.0
   135: ||           
   136: ||                     senescence(:,j) = .FALSE.
   137: ||           
   138: ||            
   139: ||                     age(:,j) = 0.0
   140: ||         
   141: ||                     when_growthinit(:,j) = undef
   142: ||           
   143: ||                     everywhere(:,j) = 0.0
   144: ||           
   145: ||                     veget(:,j) = 0.0
   146: ||           
   147: ||                     veget_max(:,j) = 0.0
   148: ||           
   149: |V-----                RIP_time(:,j) = 0.0
   150: |            
   151: |                    ENDWHERE   ! number of individuals very low
   152: |          
   153: |*----->             DO m = 1, nleafages
   154: ||         
   155: ||V---->               WHERE ( was_killed(:) )
   156: |||        
   157: |||                      leaf_age(:,j,m) = 0.0 
   158: ||V----                  leaf_frac(:,j,m) = 0.0 
   159: ||         
   160: ||                     ENDWHERE
   161: ||         
   162: |*-----              ENDDO
   163: |          
   164: |                    IF ( bavard .GE. 2 ) THEN
   165: |          
   166: |                      WRITE(numout,*) 'kill: eliminated ',PFT_name(j)
   167: |V=====                WRITE(numout,*) '  at ',COUNT( was_killed(:) ),' points after '//whichroutine
   168: |          
   169: |                    ENDIF
   170: |          
   171: |                  ENDIF     ! PFT must be killed at at least one place
   172: |          
   173: |                ENDIF       ! PFT is natural
   174: |          
   175: +------        ENDDO         ! loop over PFTs
   176:            
   177:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving kill'
   178:            
   179:              END SUBROUTINE kill
   180:            
   181:            END MODULE lpj_kill
