Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:45 2008
FILE NAME: i.stomate_lpj.f90
PROGRAM NAME: stomate_lpj
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   338  vec  (   4): Vectorized array expression.
   340  opt  (1592): Outer loop unrolled inside inner loop.
   340  vec  (   4): Vectorized array expression.
   341  opt  (1593): Loop nest collapsed into one loop.
   341  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   343  opt  (1592): Outer loop unrolled inside inner loop.
   349  opt  (1593): Loop nest collapsed into one loop.
   349  vec  (   4): Vectorized array expression.
   350  opt  (1592): Outer loop unrolled inside inner loop.
   350  vec  (   4): Vectorized array expression.
   602  warn (  80): Dummy argument "deadleaf_cover" with INTENT(OUT) attribute may be referenced before it is defined.
   602  vec  (   4): Vectorized array expression.
   611  vec  (   4): Vectorized array expression.
   620  opt  (1592): Outer loop unrolled inside inner loop.
   655  warn (  80): Dummy argument "deadleaf_cover" with INTENT(OUT) attribute may be referenced before it is defined.
   781  warn (  83): Dummy argument "soilhum_daily" is not used.
   781  warn (  83): Dummy argument "control_moist" is not used.
   781  warn (  83): Dummy argument "control_temp" is not used.
   781  warn (  83): Dummy argument "clay" is not used.
   781  warn (  83): Dummy argument "tsurf_daily" is not used.
   781  warn (  83): Dummy argument "soilcarbon_input" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:45 2008
FILE NAME: i.stomate_lpj.f90
PROGRAM NAME: stomate_lpj
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! Stomate: phenology, allocation, etc.
     2:            !
     3:            ! authors: A. Botta, P. Friedlingstein, C. Morphopoulos, N. Viovy, et al.
     4:            !
     5:            ! bits and pieces put together by G. Krinner
     6:            !
     7:            ! version 0.0: August 1998
     8:            !
     9:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_lpj.f90,v 1.14 2007/06/13 07:44:34 ssipsl Exp $
    10:            ! IPSL (2006)
    11:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    12:            !
    13:            MODULE stomate_lpj
    14:            
    15:              ! modules used:
    16:            
    17:              USE ioipsl
    18:              USE stomate_constants
    19:              USE lpj_constraints
    20:              USE lpj_pftinout
    21:              USE lpj_kill
    22:              USE lpj_crown
    23:              USE lpj_fire
    24:              USE lpj_gap
    25:              USE lpj_light
    26:              USE lpj_establish
    27:              USE lpj_cover
    28:              USE stomate_prescribe
    29:              USE stomate_phenology
    30:              USE stomate_alloc
    31:              USE stomate_npp
    32:              USE stomate_turnover
    33:              USE stomate_litter
    34:              USE stomate_soilcarbon
    35:              USE stomate_vmax
    36:              USE stomate_assimtemp
    37:            ! routine added
    38:              USE stomate_deforestation
    39:              USE stomate_natagritot
    40:            !  USE Write_Field_p
    41:            
    42:              IMPLICIT NONE
    43:            
    44:              ! private & public routines
    45:            
    46:              PRIVATE
    47:              PUBLIC StomateLpj,StomateLpj_clear
    48:            
    49:            CONTAINS
    50:             
    51:             SUBROUTINE StomateLpj_clear
    52:            
    53:               CALL prescribe_clear
    54:               CALL phenology_clear
    55:               CALL npp_calc_clear
    56:               CALL turn_clear
    57:               CALL soilcarbon_clear
    58:               CALL constraints_clear
    59:               CALL establish_clear
    60:               CALL fire_clear
    61:               CALL gap_clear
    62:               CALL light_clear
    63:               CALL pftinout_clear
    64:               CALL alloc_clear
    65:             END SUBROUTINE StomateLpj_clear
    66:            
    67:              SUBROUTINE StomateLpj (npts, dt_days, EndOfYear, &
    68:                             neighbours, resolution, space_nat, &
    69:                             clay, herbivores, &
    70:                             tsurf_daily, tsoil_daily, t2m_daily, t2m_min_daily, &
    71:                             litterhum_daily, soilhum_daily, &
    72:                             maxmoiavail_lastyear, minmoiavail_lastyear, &
    73:                             gdd0_lastyear, precip_lastyear, &
    74:                             moiavail_month, moiavail_week, tlong_ref, t2m_month, t2m_week, &
    75:                             tsoil_month, soilhum_month, &
    76:                             gdd_m5_dormance, gdd_midwinter, ncd_dormance, ngd_minus5, &
    77:                             turnover_longterm, gpp_daily, time_lowgpp, &
    78:                             time_hum_min, maxfpc_lastyear, resp_maint_part, &
    79:                             PFTpresent, age, fireindex, firelitter, &
    80:                             leaf_age, leaf_frac, biomass, ind, adapted, regenerate, &
    81:                             senescence, when_growthinit, &
    82:                             litterpart, litter, dead_leaves, carbon, black_carbon, lignin_struc, &
    83:                             veget_max, veget, npp_longterm, lm_lastyearmax, veget_lastlight, &
    84:                             everywhere, need_adjacent, RIP_time, &
    85:                             lai, rprof,npp_daily, turnover_daily, turnover_time,&
    86:                             control_moist, control_temp, soilcarbon_input, &
    87:                             co2_to_bm, co2_fire, resp_hetero, resp_maint, resp_growth, &
    88:                             height, deadleaf_cover, vcmax, vjmax, t_photo_min, t_photo_opt, t_photo_max,bm_to_litter, &
    89:                             prod10,prod100,flux10, flux100, space_nat_new,veget_max_new, &
    90:                             convflux,cflux_prod10,cflux_prod100, defor)
    91:            ! deforestation variables added as arguments
    92:            
    93:                !
    94:                ! 0 declarations
    95:                !
    96:            
    97:                ! 0.1 input
    98:            
    99:                ! Domain size
   100:                INTEGER(i_std), INTENT(in)                                           :: npts
   101:                ! time step of Stomate in days
   102:                REAL(r_std), INTENT(in)                                        :: dt_days
   103:                ! indices of the 8 neighbours of each grid point (1=N, 2=NE, 3=E, 4=SE, 5=S, 6=SW, 7=W, 8=NW)
   104:                INTEGER(i_std), DIMENSION(npts,8), INTENT(in)                 :: neighbours
   105:                ! resolution at each grid point in m (1=E-W, 2=N-S)
   106:                REAL(r_std), DIMENSION(npts,2), INTENT(in)                     :: resolution
   107:                ! total natural space (fraction of total space)
   108:            !    REAL(r_std), DIMENSION(npts), INTENT(in)                       :: space_nat
   109:                REAL(r_std), DIMENSION(npts), INTENT(inout)                    :: space_nat
   110:                ! clay fraction
   111:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: clay
   112:                ! time constant of probability of a leaf to be eaten by a herbivore (days)
   113:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: herbivores
   114:                ! daily surface temperatures (K)
   115:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: tsurf_daily
   116:                ! daily soil temperatures (K)
   117:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)                  :: tsoil_daily
   118:                ! daily 2 meter temperatures (K)
   119:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: t2m_daily
   120:                ! daily minimum 2 meter temperatures (K)
   121:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: t2m_min_daily
   122:                ! daily litter humidity
   123:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: litterhum_daily
   124:                ! daily soil humidity
   125:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)                  :: soilhum_daily
   126:                ! last year's maximum moisture availability
   127:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: maxmoiavail_lastyear
   128:                ! last year's minimum moisture availability
   129:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: minmoiavail_lastyear
   130:                ! last year's GDD0
   131:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: gdd0_lastyear
   132:                ! lastyear's precipitation (mm/year)
   133:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: precip_lastyear
   134:                ! "monthly" moisture availability
   135:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: moiavail_month
   136:                ! "weekly" moisture availability
   137:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: moiavail_week
   138:                ! "long term" 2 meter reference temperatures (K)
   139:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: tlong_ref
   140:                ! "monthly" 2-meter temperatures (K)
   141:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: t2m_month
   142:                ! "weekly" 2-meter temperatures (K)
   143:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: t2m_week
   144:                ! "monthly" soil temperatures (K)
   145:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)                  :: tsoil_month
   146:                ! "monthly" soil humidity
   147:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)                  :: soilhum_month
   148:                ! growing degree days, threshold -5 deg C (for phenology)
   149:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: gdd_m5_dormance
   150:                ! growing degree days, since midwinter (for phenology)
   151:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: gdd_midwinter
   152:                ! number of chilling days, since leaves were lost (for phenology)
   153:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: ncd_dormance
   154:                ! number of growing days, threshold -5 deg C (for phenology)
   155:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: ngd_minus5
   156:                ! "long term" turnover rate (gC/(m**2 of nat/agri ground)/year)
   157:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(in)           :: turnover_longterm
   158:                ! daily gross primary productivity (gC/(m**2 of nat/agri ground)/day)
   159:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: gpp_daily
   160:                ! duration of dormance (d)
   161:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: time_lowgpp
   162:                ! time elapsed since strongest moisture availability (d)
   163:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: time_hum_min
   164:                ! last year's maximum fpc for each natural PFT, on *natural* ground
   165:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                  :: maxfpc_lastyear
   166:                ! maintenance respiration of different plant parts (gC/day/m**2 of nat/agri ground)
   167:                REAL(r_std), DIMENSION(npts,nparts,npft), INTENT(in)             :: resp_maint_part
   168:            
   169:                ! 0.2 modified fields
   170:            
   171:                ! PFT exists
   172:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)                  :: PFTpresent
   173:                ! age (years)
   174:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: age
   175:                ! Probability of fire
   176:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(inout)          :: fireindex
   177:                ! Longer term litter above the ground, gC/m**2 of nat/agri ground
   178:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(inout)          :: firelitter
   179:                ! leaf age (days)
   180:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)     :: leaf_age
   181:                ! fraction of leaves in leaf age class
   182:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)     :: leaf_frac
   183:                ! biomass (gC/(m**2 of nat/agri ground))
   184:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)        :: biomass
   185:                ! density of individuals (1/(m**2 of nat/agri ground))
   186:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: ind
   187:                ! Winter too cold? between 0 and 1
   188:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: adapted
   189:                ! Winter sufficiently cold? between 0 and 1
   190:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: regenerate
   191:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
   192:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)                  :: senescence
   193:                ! how many days ago was the beginning of the growing season
   194:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: when_growthinit
   195:                ! fraction of litter above the ground belonging to different PFTs
   196:                REAL(r_std), DIMENSION(npts,npft,nlitt), INTENT(inout)         :: litterpart
   197:                ! metabolic and structural litter, natural and agricultural,
   198:                !   above and below ground (gC/(m**2 of nat/agri ground))
   199:                REAL(r_std), DIMENSION(npts,nlitt,nvegtypes,nlevs), INTENT(inout)  :: litter
   200:                ! dead leaves on ground, per PFT, metabolic and structural, 
   201:                !   in gC/(m**2 of nat/agri ground)
   202:                REAL(r_std), DIMENSION(npts,npft,nlitt), INTENT(inout)         :: dead_leaves
   203:                ! carbon pool: active, slow, or passive, natural and agricultural
   204:                !   (gC/(m**2 of nat/agri ground))
   205:                REAL(r_std), DIMENSION(npts,ncarb,nvegtypes), INTENT(inout)    :: carbon
   206:                ! black carbon on the ground (gC/(m**2 of total ground))
   207:                REAL(r_std), DIMENSION(npts), INTENT(inout)                    :: black_carbon
   208:                ! ratio Lignine/Carbon in structural litter, above and below ground,
   209:                !   natural and agricultural (gC/(m**2 of nat/agri ground))
   210:                REAL(r_std), DIMENSION(npts,nvegtypes,nlevs), INTENT(inout)    :: lignin_struc
   211:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
   212:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: veget_max
   213:                ! fractional coverage on natural/agricultural ground, taking into
   214:                !   account LAI (=grid-scale fpc)
   215:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: veget
   216:                ! "long term" net primary productivity (gC/(m**2 of nat/agri ground)/year)
   217:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: npp_longterm
   218:                ! last year's maximum leaf mass, for each PFT (gC/(m**2 of nat/agri ground))
   219:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: lm_lastyearmax
   220:                ! vegetation fractions (on natural/agri ground) after last light competition
   221:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: veget_lastlight
   222:                ! is the PFT everywhere in the grid box or very localized (after its introduction)
   223:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: everywhere
   224:                ! in order for this PFT to be introduced, does it have to be present in an
   225:                !   adjacent grid box?
   226:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)                  :: need_adjacent
   227:                ! How much time ago was the PFT eliminated for the last time (y)
   228:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: RIP_time
   229:                ! Turnover_time of leaves for grasses (d)
   230:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)          :: turnover_time
   231:             
   232:                ! 0.3 output
   233:            
   234:                ! leaf area index OF AN INDIVIDUAL PLANT
   235:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                 :: lai
   236:                ! root depth. This will, one day, be a prognostic variable. It will be calculated by
   237:                ! STOMATE (save in restart file & give to hydrology module!), probably somewhere
   238:                ! in the allocation routine. For the moment, it is prescribed.
   239:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                 :: rprof
   240:                ! net primary productivity (gC/day/(m**2 of nat/agri ground))
   241:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: npp_daily
   242:                ! Turnover rates (gC/(m**2 of nat/agri ground)/day)
   243:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(out)          :: turnover_daily
   244:                ! moisture control of heterotrophic respiration
   245:                REAL(r_std), DIMENSION(npts,nlevs), INTENT(inout)                :: control_moist
   246:                ! temperature control of heterotrophic respiration, above and below
   247:                REAL(r_std), DIMENSION(npts,nlevs), INTENT(inout)                :: control_temp
   248:                ! quantity of carbon going into carbon pools from litter decomposition
   249:                !   (gC/(m**2 of nat/agri ground)/day)
   250:                REAL(r_std), DIMENSION(npts,ncarb,nvegtypes), INTENT(inout)      :: soilcarbon_input
   251:                ! co2 taken up (gC/(m**2 of total ground)/day)
   252:                REAL(r_std), DIMENSION(npts), INTENT(out)                      :: co2_to_bm
   253:                ! carbon emitted into the atmosphere by fire (living and dead biomass)
   254:                ! (in gC/m**2 of total ground/day)
   255:                REAL(r_std), DIMENSION(npts), INTENT(out)                      :: co2_fire
   256:                ! heterotrophic respiration (gC/day/m**2 of total ground)
   257:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(inout)            :: resp_hetero
   258:                ! maintenance respiration (gC/day/(m**2 of total ground))
   259:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: resp_maint
   260:                ! growth respiration (gC/day/(m**2 of total ground))
   261:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: resp_growth
   262:                ! height of vegetation (m)
   263:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                 :: height
   264:                ! fraction of soil covered by dead leaves
   265:                REAL(r_std), DIMENSION(npts), INTENT(out)                      :: deadleaf_cover
   266:                ! Maximum rate of carboxylation
   267:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: vcmax
   268:                ! Maximum rate of RUbp regeneration
   269:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: vjmax
   270:                ! Minimum temperature for photosynthesis (deg C)
   271:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: t_photo_min
   272:                ! Optimum temperature for photosynthesis (deg C)
   273:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: t_photo_opt
   274:                ! Maximum temperature for photosynthesis (deg C)
   275:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)                 :: t_photo_max
   276:                ! conversion of biomass to litter (gC/(m**2 of nat/agri ground)) / day
   277:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(out)          :: bm_to_litter
   278:            
   279:                ! 0.4 local
   280:            
   281:                ! conversion of biomass to litter (gC/(m**2 of nat/agri ground)) / day
   282:            !    REAL(r_std), DIMENSION(npts,npft,nparts)                       :: bm_to_litter
   283:                 ! total conversion of biomass to litter (gC/(m**2)) / day
   284:                REAL(r_std), DIMENSION(npts,npft)                                   :: tot_bm_to_litter
   285:                ! total living biomass (gC/(m**2)) 
   286:                REAL(r_std), DIMENSION(npts,npft)                                   :: tot_live_biomass
   287:                ! total turnover rate (gC/(m**2)) / day
   288:                REAL(r_std), DIMENSION(npts,npft)                                   :: tot_turnover
   289:                ! total soil and litter carbon (gC/(m**2))
   290:                REAL(r_std), DIMENSION(npts)                                   :: tot_soil_carb
   291:               ! crown area of individuals (m**2)
   292:                REAL(r_std), DIMENSION(npts,npft)                              :: cn_ind
   293:                ! fraction that goes into plant part
   294:                REAL(r_std), DIMENSION(npts,npft,nparts)                       :: f_alloc
   295:                ! space availability for trees
   296:                REAL(r_std), DIMENSION(npts)                                   :: avail_tree
   297:                ! space availability for grasses
   298:                REAL(r_std), DIMENSION(npts)                                   :: avail_grass
   299:            
   300:                ! deforestation variables + EndOfYear
   301:                ! Do update of yearly variables? This variable must be .TRUE. once a year
   302:                LOGICAL                                                       :: EndOfYear
   303:                ! new "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
   304:                REAL(r_std), DIMENSION(npts,npft),INTENT(in)                :: veget_max_new 
   305:                ! new total natural space (fraction of total space)
   306:                REAL(r_std), DIMENSION(npts), INTENT(in)                       :: space_nat_new
   307:                ! products remaining in the 10/100 year-turnover pool after the annual release for each compartment
   308:                ! (10 or 100 + 1 : input from year of deforestation)
   309:                REAL(r_std),DIMENSION(npts,0:10), INTENT(inout)                        :: prod10
   310:                REAL(r_std),DIMENSION(npts,0:100), INTENT(inout)                       :: prod100
   311:                ! annual release from the 10/100 year-turnover pool compartments
   312:                REAL(r_std),DIMENSION(npts,10), INTENT(inout)                       :: flux10
   313:                REAL(r_std),DIMENSION(npts,100), INTENT(inout)                      :: flux100
   314:                ! release during first year following deforestation
   315:                REAL(r_std),DIMENSION(npts)                                         :: convflux
   316:                ! total annual release from the 10/100 year-turnover pool
   317:                REAL(r_std),DIMENSION(npts)                                   :: cflux_prod10, cflux_prod100
   318:                ! total products remaining in the pool after the annual release 
   319:                REAL(r_std),DIMENSION(npts)                                   :: prod10_total, prod100_total 
   320:                ! total flux from conflux and the 10/100 year-turnover pool 
   321:                REAL(r_std),DIMENSION(npts)                                       :: cflux_prod_total
   322:               ! deforestation flag
   323:                LOGICAL, INTENT(in)                         :: defor
   324:            
   325:            
   326:                ! =========================================================================
   327:            
   328:                IF (bavard.GE.3) WRITE(numout,*) 'Entering stomate_lpj'
   329:            
   330:                !
   331:                ! 1 Initializations
   332:                !
   333:            
   334:                !
   335:                ! 1.1 set outputs to zero
   336:                !
   337:            
   338: V------>       co2_to_bm(:) = 0.0
   339: V------        co2_fire(:) = 0.0
   340: +V=====         npp_daily(:,:) = 0.0
   341: W**====        turnover_daily(:,:,:) = 0.0
   342: *V----->       resp_maint(:,:) = 0.0
   343: *V-----        resp_growth(:,:) = 0.0
   344:            
   345:                !
   346:                ! 1.2  initialize some variables
   347:                !
   348:            
   349: W++====        bm_to_litter(:,:,:) = 0.0
   350: +V=====        cn_ind(:,:) = 0.0
   351:            
   352:                !
   353:                ! 1.3 Prescribe some vegetation characteristics if the vegetation is not dynamic and
   354:                !       for agricultural PFTs.
   355:                !     IF the DGVM is not activated, the density of individuals and their crown
   356:                !     areas don't matter, but they should be defined for the case we switch on
   357:                !     the DGVM afterwards.
   358:                !     At first call, if the DGVM is not activated, impose a minimum biomass for 
   359:                !       prescribed PFTs and declare them present.
   360:                !
   361:            
   362:                CALL prescribe (npts, &
   363:                                space_nat, &
   364:                                veget_max, PFTpresent, everywhere, when_growthinit, &
   365:                                biomass, leaf_frac, ind, cn_ind)
   366:            
   367:                !
   368:                ! 2 climatic constraints for PFT presence and regenerativeness
   369:                !   call this even when DGVM is not activated so that "adapted" and "regenerate"
   370:                !   are kept up to date for the moment when the DGVM is activated.
   371:                !
   372:            
   373:                CALL constraints (npts, dt_days, &
   374:                                  t2m_month, t2m_min_daily, when_growthinit, &
   375:                                  adapted, regenerate)
   376:            
   377:                !
   378:                ! 3 PFTs in and out, based on climate criteria
   379:                !
   380:            
   381:                IF ( control%ok_dgvm ) THEN
   382:            
   383:                  !
   384:                  ! 3.1 do introduction/elimination
   385:                  !
   386:            
   387:                  CALL pftinout (npts, dt_days, adapted, regenerate, &
   388:                           neighbours, space_nat, veget, veget_max, &
   389:                           biomass, ind, age, leaf_frac, npp_longterm, lm_lastyearmax, senescence, &
   390:                           PFTpresent, everywhere, when_growthinit, need_adjacent, RIP_time, &
   391:                           co2_to_bm, &
   392:                           avail_tree, avail_grass)
   393:            
   394:                  !
   395:                  ! 3.2 reset attributes for eliminated PFTs.
   396:                  !     This also kills PFTs that had 0 leafmass during the last year. The message
   397:                  !     "... after pftinout" is misleading in this case.
   398:                  !
   399:            
   400:                  CALL kill (npts, 'pftinout  ', lm_lastyearmax, &
   401:                             ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
   402:                             lai, age, leaf_age, leaf_frac, &
   403:                             when_growthinit, everywhere, veget, veget_max, bm_to_litter)
   404:            
   405:                  !
   406:                  ! 3.3 calculate new crown area and maximum vegetation cover
   407:                  !
   408:            
   409:                  CALL crown (npts, PFTpresent, &
   410:                              ind, biomass, &
   411:                              veget_max, cn_ind, height)
   412:            
   413:                ENDIF
   414:            
   415:                !
   416:                ! 4 phenology
   417:                !
   418:            
   419:                CALL phenology (npts, dt_days, PFTpresent, &
   420:                                veget_max, space_nat, &
   421:                                tlong_ref, t2m_month, t2m_week, gpp_daily, &
   422:                                maxmoiavail_lastyear, minmoiavail_lastyear, &
   423:                                moiavail_month, moiavail_week, &
   424:                                gdd_m5_dormance, gdd_midwinter, ncd_dormance, ngd_minus5, &
   425:                                senescence, time_lowgpp, time_hum_min, &
   426:                                biomass, leaf_frac, leaf_age, &
   427:                                when_growthinit, co2_to_bm, lai)
   428:            
   429:                !
   430:                ! 5 allocation
   431:                !
   432:            
   433:                CALL alloc (npts, dt_days, &
   434:                            lai, veget_max, senescence, when_growthinit, &
   435:                            moiavail_week, tsoil_month, soilhum_month, &
   436:                            biomass, leaf_age, leaf_frac, rprof, f_alloc)
   437:            
   438:                !
   439:                ! 6 maintenance and growth respiration. NPP
   440:                !
   441:            
   442:                CALL npp_calc (npts, dt_days, space_nat, &
   443:                               PFTpresent, &
   444:                               tlong_ref, t2m_daily, tsoil_daily, lai, rprof, &
   445:                               gpp_daily, f_alloc, resp_maint_part,&
   446:                               biomass, leaf_age, leaf_frac, age, &
   447:                               resp_maint, resp_growth, npp_daily)
   448:            
   449:                IF ( control%ok_dgvm ) THEN
   450:            
   451:                  ! new provisional crown area and maximum vegetation cover after growth
   452:            
   453:                  CALL crown (npts, PFTpresent, &
   454:                              ind, biomass, &
   455:                              veget_max, cn_ind, height)
   456:            
   457:                ENDIF
   458:            
   459:                !
   460:                ! 7 fire.
   461:                !
   462:            
   463:                CALL fire (npts, dt_days, space_nat, litterpart, &
   464:                           litterhum_daily, t2m_daily, lignin_struc, &
   465:                           fireindex, firelitter, biomass, ind, &
   466:                           litter, dead_leaves, bm_to_litter, black_carbon, &
   467:                           co2_fire)
   468:            
   469:                IF ( control%ok_dgvm ) THEN
   470:            
   471:                  ! reset attributes for eliminated PFTs
   472:            
   473:                  CALL kill (npts, 'fire      ', lm_lastyearmax, &
   474:                             ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
   475:                             lai, age, leaf_age, leaf_frac, &
   476:                             when_growthinit, everywhere, veget, veget_max, bm_to_litter)
   477:            
   478:                ENDIF
   479:            
   480:                !
   481:                ! 8 tree mortality. Does not depend on age, therefore does not change crown area.
   482:                !
   483:            
   484:                CALL gap (npts, dt_days, &
   485:                          npp_longterm, turnover_longterm, lm_lastyearmax, &
   486:                          PFTpresent, biomass, ind, bm_to_litter)
   487:            
   488:                IF ( control%ok_dgvm ) THEN
   489:            
   490:                  ! reset attributes for eliminated PFTs
   491:            
   492:                  CALL kill (npts, 'gap       ', lm_lastyearmax, &
   493:                             ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
   494:                             lai, age, leaf_age, leaf_frac, &
   495:                             when_growthinit, everywhere, veget, veget_max, bm_to_litter)
   496:            
   497:                ENDIF
   498:            
   499:                !
   500:                ! 9 calculate vcmax, vjmax and photosynthesis temperatures
   501:                !
   502:            
   503:                CALL vmax (npts, dt_days, &
   504:                           leaf_age, leaf_frac, &
   505:                           vcmax, vjmax)
   506:            
   507:                CALL assim_temp (npts, tlong_ref, t2m_month, &
   508:                                 t_photo_min, t_photo_opt, t_photo_max)
   509:            
   510:                !
   511:                ! 10 leaf senescence and other turnover processes. New lai
   512:                !
   513:            
   514:                CALL turn (npts, dt_days, PFTpresent, &
   515:                           herbivores, &
   516:                           maxmoiavail_lastyear, minmoiavail_lastyear, &
   517:                           moiavail_week,  moiavail_month,tlong_ref, t2m_month, t2m_week, veget_max, &
   518:                           leaf_age, leaf_frac, age, lai, biomass, &
   519:                           turnover_daily, senescence,turnover_time)
   520:            
   521:                !
   522:                ! 11 light competition
   523:                !
   524:            
   525:                IF ( control%ok_dgvm ) THEN
   526:            
   527:                  !
   528:                  ! 11.1 do light competition
   529:                  !
   530:            
   531:                  CALL light (npts, dt_days, &
   532:                              PFTpresent, cn_ind, lai, maxfpc_lastyear, &
   533:                              ind, biomass, veget_lastlight, bm_to_litter)
   534:            
   535:                  !
   536:                  ! 11.2 reset attributes for eliminated PFTs
   537:                  !
   538:            
   539:                  CALL kill (npts, 'light     ', lm_lastyearmax, &
   540:                             ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
   541:                             lai, age, leaf_age, leaf_frac, &
   542:                             when_growthinit, everywhere, veget, veget_max, bm_to_litter)
   543:            
   544:                ENDIF
   545:            
   546:                !
   547:                ! 12 establishment of saplings
   548:                !
   549:            
   550:                IF ( control%ok_dgvm ) THEN
   551:            
   552:                  !
   553:                  ! 12.1 do establishment
   554:                  !
   555:            
   556:                  CALL establish (npts, dt_days, PFTpresent, regenerate, &
   557:                                  neighbours, resolution, space_nat, need_adjacent, herbivores, &
   558:                                  precip_lastyear, gdd0_lastyear, lm_lastyearmax, &
   559:                                  cn_ind, lai, avail_tree, avail_grass, &
   560:                                  leaf_age, leaf_frac, &
   561:                                  ind, biomass, age, everywhere, co2_to_bm)
   562:            
   563:                  !
   564:                  ! 12.2 calculate new crown area (and maximum vegetation cover)
   565:                  !
   566:            
   567:                  CALL crown (npts, PFTpresent, &
   568:                              ind, biomass, &
   569:                              veget_max, cn_ind, height)
   570:            
   571:                ENDIF
   572:            
   573:                !
   574:                ! 13 calculate final LAI and vegetation cover.
   575:                !
   576:            
   577:                CALL cover (npts, cn_ind, ind, biomass, &
   578:                            veget_max, veget, lai)
   579:            
   580:                !
   581:                ! 14 the whole litter stuff:
   582:                !    litter update, lignin content, PFT parts, litter decay, 
   583:                !    litter heterotrophic respiration, dead leaf soil cover.
   584:                !    No vertical discretisation in the soil for litter decay.
   585:                !
   586:            
   587:                ! 15.1  deforestation
   588:                IF(defor) then
   589:                   IF(EndOfYear) then
   590:                   CALL deforestation (npts, dt_days, space_nat,space_nat_new, veget_max, veget_max_new, &
   591:                        biomass, ind, age, PFTpresent, senescence, when_growthinit, &
   592:                        everywhere, veget, & 
   593:                        co2_to_bm, bm_to_litter, bm_sapl, tree, cn_ind,flux10,flux100, &
   594:                        prod10,prod100,prod10_total,prod100_total,&
   595:                        convflux,cflux_prod_total,cflux_prod10,cflux_prod100,leaf_frac,&
   596:                        npp_longterm, lm_lastyearmax)
   597:            
   598:                   ENDIF
   599:                ENDIF
   600:            
   601:            
   602: V======       tot_soil_carb = (litter(:,istructural,inat,iabove)  +  litter(:,imetabolic,inat,iabove) + &
   603:                     &          litter(:,istructural,inat,ibelow) + litter(:,imetabolic,inat,ibelow) + &
   604:                     &           carbon(:,iactive,inat) + &
   605:                     &          carbon(:,islow,inat)+  carbon(:,ipassive,inat))*space_nat(:) + &
   606:                     &          (litter(:,istructural,iagri,iabove)+ litter(:,istructural,iagri,ibelow) + &
   607:                     &          litter(:,imetabolic,iagri,ibelow) +  litter(:,imetabolic,iagri,iabove) + &
   608:                     &          carbon(:,iactive,iagri) + carbon(:,islow,iagri) +  &
   609:                     &          carbon(:,ipassive,iagri))*(1-space_nat(:))+ deadleaf_cover
   610:            
   611: *V----->       tot_live_biomass = biomass(:,:,ileaf) + biomass(:,:,isapabove) + biomass(:,:,isapbelow) +&
   612: ||                  &             biomass(:,:,iheartabove) + biomass(:,:,iheartbelow) + &
   613: ||                  &             biomass(:,:,iroot)+ biomass(:,:,ifruit)+ biomass(:,:,icarbres)
   614: ||         
   615: ||             tot_turnover = turnover_daily(:,:,ileaf) + turnover_daily(:,:,isapabove) + &
   616: ||                  &         turnover_daily(:,:,isapbelow) + turnover_daily(:,:,iheartabove) + &
   617: ||                  &         turnover_daily(:,:,iheartbelow) + turnover_daily(:,:,iroot) + &
   618: ||                  &         turnover_daily(:,:,ileaf) + turnover_daily(:,:,icarbres)
   619: ||         
   620: *V-----        tot_bm_to_litter = bm_to_litter(:,:,ileaf) + bm_to_litter(:,:,isapabove) +&
   621:                     &             bm_to_litter(:,:,isapbelow) + bm_to_litter(:,:,iheartbelow) +&
   622:                     &             bm_to_litter(:,:,iheartabove) + bm_to_litter(:,:,iroot) + &
   623:                     &             bm_to_litter(:,:,ifruit) + bm_to_litter(:,:,icarbres)
   624:            
   625:                !
   626:                ! 17 history
   627:                !
   628:            
   629:                ! 2d
   630:            
   631:                CALL histwrite (hist_id_stomate, 'RESOLUTION_X', itime, &
   632:                                resolution(:,1), npts, hori_index)
   633:                CALL histwrite (hist_id_stomate, 'RESOLUTION_Y', itime, &
   634:                                resolution(:,2), npts, hori_index)
   635:                CALL histwrite (hist_id_stomate, 'SPACE_NAT', itime, &
   636:                                space_nat(:), npts, hori_index)
   637:            !    CALL histwrite (hist_id_stomate, 'TOTAL_SOIL_CARB', itime, &
   638:            !                    tot_soil_carb, npts, hori_index)
   639:                CALL histwrite (hist_id_stomate, 'LITTER_STR_AB_NAT', itime, &
   640:                                litter(:,istructural,inat,iabove), npts, hori_index)
   641:                CALL histwrite (hist_id_stomate, 'LITTER_STR_AB_AGRI', itime, &
   642:                                litter(:,istructural,iagri,iabove), npts, hori_index)
   643:                CALL histwrite (hist_id_stomate, 'LITTER_MET_AB_NAT', itime, &
   644:                                litter(:,imetabolic,inat,iabove), npts, hori_index)
   645:                CALL histwrite (hist_id_stomate, 'LITTER_MET_AB_AGRI', itime, &
   646:                                litter(:,imetabolic,iagri,iabove), npts, hori_index)
   647:                CALL histwrite (hist_id_stomate, 'LITTER_STR_BE_NAT', itime, &
   648:                                litter(:,istructural,inat,ibelow), npts, hori_index)
   649:                CALL histwrite (hist_id_stomate, 'LITTER_STR_BE_AGRI', itime, &
   650:                                litter(:,istructural,iagri,ibelow), npts, hori_index)
   651:                CALL histwrite (hist_id_stomate, 'LITTER_MET_BE_NAT', itime, &
   652:                                litter(:,imetabolic,inat,ibelow), npts, hori_index)
   653:                CALL histwrite (hist_id_stomate, 'LITTER_MET_BE_AGRI', itime, &
   654:                                litter(:,imetabolic,iagri,ibelow), npts, hori_index)
   655:                CALL histwrite (hist_id_stomate, 'DEADLEAF_COVER', itime, &
   656:                                deadleaf_cover, npts, hori_index)
   657:                CALL histwrite (hist_id_stomate, 'CARBON_ACTIVE_NAT', itime, &
   658:                                carbon(:,iactive,inat), npts, hori_index)
   659:                CALL histwrite (hist_id_stomate, 'CARBON_ACTIVE_AGRI', itime, &
   660:                                carbon(:,iactive,iagri), npts, hori_index)
   661:                CALL histwrite (hist_id_stomate, 'CARBON_SLOW_NAT', itime, &
   662:                                carbon(:,islow,inat), npts, hori_index)
   663:                CALL histwrite (hist_id_stomate, 'CARBON_SLOW_AGRI', itime, &
   664:                                carbon(:,islow,iagri), npts, hori_index)
   665:                CALL histwrite (hist_id_stomate, 'CARBON_PASSIVE_NAT', itime, &
   666:                                carbon(:,ipassive,inat), npts, hori_index)
   667:                CALL histwrite (hist_id_stomate, 'CARBON_PASSIVE_AGRI', itime, &
   668:                                carbon(:,ipassive,iagri), npts, hori_index)
   669:                CALL histwrite (hist_id_stomate, 'T2M_MONTH', itime, &
   670:                                t2m_month, npts, hori_index)
   671:                CALL histwrite (hist_id_stomate, 'T2M_WEEK', itime, &
   672:                                t2m_week, npts, hori_index)
   673:                CALL histwrite (hist_id_stomate, 'HET_RESP_NAT', itime, &
   674:                                resp_hetero(:,inat), npts, hori_index)
   675:                CALL histwrite (hist_id_stomate, 'HET_RESP_AGRI', itime, &
   676:                                resp_hetero(:,iagri), npts, hori_index)
   677:                CALL histwrite (hist_id_stomate, 'BLACK_CARBON', itime, &
   678:                                black_carbon, npts, hori_index)
   679:                CALL histwrite (hist_id_stomate, 'FIREINDEX_NAT', itime, &
   680:                                fireindex(:,inat), npts, hori_index)
   681:                CALL histwrite (hist_id_stomate, 'LITTERHUM', itime, &
   682:                                litterhum_daily, npts, hori_index)
   683:                CALL histwrite (hist_id_stomate, 'CO2_FIRE', itime, &
   684:                                co2_fire, npts, hori_index)
   685:               CALL histwrite (hist_id_stomate, 'CO2_TAKEN', itime, &
   686:                                co2_to_bm, npts, hori_index)
   687:            ! deforestation variables
   688:                CALL histwrite (hist_id_stomate, 'CONVFLUX', itime, &
   689:                     convflux, npts, hori_index)
   690:                CALL histwrite (hist_id_stomate, 'CFLUX_PROD10', itime, &
   691:                     cflux_prod10, npts, hori_index)
   692:                CALL histwrite (hist_id_stomate, 'CFLUX_PROD100', itime, &
   693:                     cflux_prod100, npts, hori_index)
   694:            
   695:                ! 3d
   696:            
   697:                CALL histwrite (hist_id_stomate, 'LAI', itime, &
   698:                                lai, npts*npft, horipft_index)
   699:                CALL histwrite (hist_id_stomate, 'VEGET', itime, &
   700:                                veget, npts*npft, horipft_index)
   701:                CALL histwrite (hist_id_stomate, 'VEGET_MAX', itime, &
   702:                                veget_max, npts*npft, horipft_index)
   703:                CALL histwrite (hist_id_stomate, 'NPP', itime, &
   704:                                npp_daily, npts*npft, horipft_index)
   705:                CALL histwrite (hist_id_stomate, 'GPP', itime, &
   706:                                gpp_daily, npts*npft, horipft_index)
   707:                CALL histwrite (hist_id_stomate, 'IND', itime, &
   708:                                ind, npts*npft, horipft_index)
   709:            !    CALL histwrite (hist_id_stomate, 'TOTAL_M', itime, &
   710:            !                    tot_live_biomass, npts*npft, horipft_index)
   711:                CALL histwrite (hist_id_stomate, 'LEAF_M', itime, &
   712:                                biomass(:,:,ileaf), npts*npft, horipft_index)
   713:                CALL histwrite (hist_id_stomate, 'SAP_M_AB', itime, &
   714:                                biomass(:,:,isapabove), npts*npft, horipft_index)
   715:                CALL histwrite (hist_id_stomate, 'SAP_M_BE', itime, &
   716:                                biomass(:,:,isapbelow), npts*npft, horipft_index)
   717:                CALL histwrite (hist_id_stomate, 'HEART_M_AB', itime, &
   718:                                biomass(:,:,iheartabove), npts*npft, horipft_index)
   719:                CALL histwrite (hist_id_stomate, 'HEART_M_BE', itime, &
   720:                                biomass(:,:,iheartbelow), npts*npft, horipft_index)
   721:                CALL histwrite (hist_id_stomate, 'ROOT_M', itime, &
   722:                                biomass(:,:,iroot), npts*npft, horipft_index)
   723:                CALL histwrite (hist_id_stomate, 'FRUIT_M', itime, &
   724:                                biomass(:,:,ifruit), npts*npft, horipft_index)
   725:                CALL histwrite (hist_id_stomate, 'RESERVE_M', itime, &
   726:                                biomass(:,:,icarbres), npts*npft, horipft_index)
   727:            !    CALL histwrite (hist_id_stomate, 'TOTAL_TURN', itime, &
   728:            !                    tot_turnover, npts*npft, horipft_index)
   729:                CALL histwrite (hist_id_stomate, 'LEAF_TURN', itime, &
   730:                                turnover_daily(:,:,ileaf), npts*npft, horipft_index)
   731:                CALL histwrite (hist_id_stomate, 'SAP_AB_TURN', itime, &
   732:                                turnover_daily(:,:,isapabove), npts*npft, horipft_index)
   733:                CALL histwrite (hist_id_stomate, 'ROOT_TURN', itime, &
   734:                                turnover_daily(:,:,iroot), npts*npft, horipft_index)
   735:                CALL histwrite (hist_id_stomate, 'FRUIT_TURN', itime, &
   736:                                turnover_daily(:,:,ifruit), npts*npft, horipft_index)
   737:            !    CALL histwrite (hist_id_stomate, 'TOTAL_BM_LITTER', itime, &
   738:            !                    tot_bm_to_litter, npts*npft, horipft_index)
   739:                CALL histwrite (hist_id_stomate, 'LEAF_BM_LITTER', itime, &
   740:                                bm_to_litter(:,:,ileaf), npts*npft, horipft_index)
   741:                CALL histwrite (hist_id_stomate, 'SAP_AB_BM_LITTER', itime, &
   742:                                bm_to_litter(:,:,isapabove), npts*npft, horipft_index)
   743:                CALL histwrite (hist_id_stomate, 'SAP_BE_BM_LITTER', itime, &
   744:                                bm_to_litter(:,:,isapbelow), npts*npft, horipft_index)
   745:                CALL histwrite (hist_id_stomate, 'HEART_AB_BM_LITTER', itime, &
   746:                                bm_to_litter(:,:,iheartabove), npts*npft, horipft_index)
   747:                CALL histwrite (hist_id_stomate, 'HEART_BE_BM_LITTER', itime, &
   748:                                bm_to_litter(:,:,iheartbelow), npts*npft, horipft_index)
   749:                CALL histwrite (hist_id_stomate, 'ROOT_BM_LITTER', itime, &
   750:                                bm_to_litter(:,:,iroot), npts*npft, horipft_index)
   751:                CALL histwrite (hist_id_stomate, 'FRUIT_BM_LITTER', itime, &
   752:                                bm_to_litter(:,:,ifruit), npts*npft, horipft_index)
   753:                CALL histwrite (hist_id_stomate, 'RESERVE_BM_LITTER', itime, &
   754:                                bm_to_litter(:,:,icarbres), npts*npft, horipft_index)
   755:                CALL histwrite (hist_id_stomate, 'MAINT_RESP', itime, &
   756:                                resp_maint, npts*npft, horipft_index)
   757:                CALL histwrite (hist_id_stomate, 'GROWTH_RESP', itime, &
   758:                                resp_growth, npts*npft, horipft_index)
   759:                CALL histwrite (hist_id_stomate, 'AGE', itime, &
   760:                                age, npts*npft, horipft_index)
   761:                CALL histwrite (hist_id_stomate, 'HEIGHT', itime, &
   762:                                height, npts*npft, horipft_index)
   763:                CALL histwrite (hist_id_stomate, 'MOISTRESS', itime, &
   764:                                moiavail_week, npts*npft, horipft_index)
   765:                CALL histwrite (hist_id_stomate, 'VCMAX', itime, &
   766:                     vcmax, npts*npft, horipft_index)
   767:                CALL histwrite (hist_id_stomate, 'TURNOVER_TIME', itime, &
   768:                     turnover_time, npts*npft, horipft_index)
   769:            ! deforestation variables
   770:                   CALL histwrite (hist_id_stomate, 'PROD10', itime, &
   771:                                    prod10, npts*11, horip11_index)
   772:                   CALL histwrite (hist_id_stomate, 'PROD100', itime, &
   773:                                    prod100, npts*101, horip101_index)
   774:                   CALL histwrite (hist_id_stomate, 'FLUX10', itime, &
   775:                                    flux10, npts*10, horip10_index)
   776:                   CALL histwrite (hist_id_stomate, 'FLUX100', itime, &
   777:                                    flux100, npts*100, horip100_index)
   778:            
   779:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving stomate_lpj'
   780:            
   781:              END SUBROUTINE StomateLpj
   782:            
   783:            END MODULE stomate_lpj
