Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:44 2008
FILE NAME: i.stomate_natagritot.f90
PROGRAM NAME: stomate_natagritot
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    57  vec  (   3): Unvectorized loop.
    57  vec  (  13): Overhead of loop division is too large.
    61  opt  (1082): Backward transfers inhibit loop optimization.
    61  vec  (   4): Vectorized array expression.
    69  opt  (1082): Backward transfers inhibit loop optimization.
    69  vec  (   4): Vectorized array expression.
    85  vec  (   3): Unvectorized loop.
    85  vec  (  13): Overhead of loop division is too large.
    89  vec  (   4): Vectorized array expression.
    93  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:44 2008
FILE NAME: i.stomate_natagritot.f90
PROGRAM NAME: stomate_natagritot
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! Transform from (X per m**2 of total ground) to (X per m**2 of nat/agri ground)
     2:            ! and inverse operation
     3:            !
     4:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_natagritot.f90,v 1.6 2007/05/28 14:49:02 ssipsl Exp $
     5:            ! IPSL (2006)
     6:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     7:            !
     8:            MODULE stomate_natagritot
     9:            
    10:              ! modules used:
    11:            
    12:              USE ioipsl
    13:              USE stomate_constants
    14:            
    15:              IMPLICIT NONE
    16:            
    17:              ! private & public routines
    18:            
    19:              PRIVATE
    20:              PUBLIC natagritot
    21:            
    22:            CONTAINS
    23:            
    24:              SUBROUTINE natagritot (npts, direction, space_nat, field)
    25:            
    26:                !
    27:                ! 0 declarations
    28:                !
    29:            
    30:                ! 0.1 input
    31:            
    32:                ! Domain size
    33:                INTEGER(i_std), INTENT(in)                               :: npts
    34:                ! total -> nat/agri or nat/agri -> total ?
    35:                INTEGER(i_std), INTENT(in)                        :: direction
    36:                ! total natural space
    37:                REAL(r_std), DIMENSION(npts), INTENT(in)           :: space_nat
    38:            
    39:                ! 0.2 modified 2-dimensional field
    40:            
    41:                ! characteristic to be transformed
    42:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)   :: field
    43:            
    44:                ! 0.3 local
    45:            
    46:                ! index
    47:                INTEGER(i_std)                                    :: j
    48:            
    49:                ! =========================================================================
    50:            
    51:                IF ( direction .EQ. ito_natagri ) THEN
    52:            
    53:                  !
    54:                  ! 1 Transform from (X per m**2 of total ground) to (X per m**2 of nat/agri ground)
    55:                  !
    56:            
    57: +------>         DO j = 1, npft
    58: |          
    59: |                  IF ( natural(j) ) THEN
    60: |          
    61: |V----->             WHERE ( space_nat(:) .GT. 0.0 )
    62: ||                     field(:,j) = field(:,j) / space_nat(:)
    63: ||                   ELSEWHERE
    64: |V-----                field(:,j) = 0.0
    65: |                    ENDWHERE
    66: |          
    67: |                  ELSE
    68: |          
    69: |V----->             WHERE ( space_nat(:) .LT. 1.0 )
    70: ||                     field(:,j) = field(:,j) / ( 1. - space_nat(:) )
    71: ||                   ELSEWHERE
    72: |V-----                field(:,j) = 0.0
    73: |                    ENDWHERE
    74: |          
    75: |                  ENDIF
    76: |          
    77: +------          ENDDO
    78:            
    79:                ELSEIF ( direction .EQ. ito_total ) THEN
    80:            
    81:                  !
    82:                  ! 2 Transform from (X per m**2 of nat/agri ground) to (X per m**2 of total ground)
    83:                  !
    84:            
    85: +------>         DO j = 1, npft
    86: |          
    87: |                  IF ( natural(j) ) THEN
    88: |          
    89: |V=====              field(:,j) = field(:,j) * space_nat(:)
    90: |          
    91: |                  ELSE
    92: |          
    93: |V=====              field(:,j) = field(:,j) * ( 1. - space_nat(:) )
    94: |          
    95: |                  ENDIF
    96: |          
    97: +------          ENDDO
    98:            
    99:            
   100:                ELSE
   101:            
   102:                  STOP 'natagritot: wrong direction'
   103:            
   104:                ENDIF
   105:            
   106:              END SUBROUTINE natagritot
   107:            
   108:            END MODULE stomate_natagritot
