Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:39 2008
FILE NAME: i.stomate_soilcarbon.f90
PROGRAM NAME: stomate_soilcarbon
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    85  obsol(  18): CHARACTER* form of character declaration is used.
   106  vec  (   4): Vectorized array expression.
   142  vec  (   3): Unvectorized loop.
   142  vec  (   7): Iteration count is too small.
   156  vec  (   4): Vectorized array expression.
   156  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   162  vec  (   4): Vectorized array expression.
   175  vec  (   4): Vectorized array expression.
   175  vec  (   4): Vectorized array expression.
   175  vec  (   4): Vectorized array expression.
   186  vec  (   3): Unvectorized loop.
   190  vec  (   4): Vectorized array expression.
   194  opt  (1019): Feedback of scalar value from one loop pass to another.
   194  vec  (   4): Vectorized array expression.
   199  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   223  vec  (   4): Vectorized array expression.
   223  vec  (   4): Vectorized array expression.
   223  vec  (   4): Vectorized array expression.
   234  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:39 2008
FILE NAME: i.stomate_soilcarbon.f90
PROGRAM NAME: stomate_soilcarbon
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            !
     2:            ! Soil dynamics. Essentially after Century.
     3:            ! FOR THE MOMENT, NO VERTICAL DISCRETISATION !!!!
     4:            !
     5:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_soilcarbon.f90,v 1.6 2007/05/28 14:49:02 ssipsl Exp $
     6:            ! IPSL (2006)
     7:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     8:            !
     9:            MODULE stomate_soilcarbon
    10:            
    11:              ! modules used:
    12:            
    13:              USE ioipsl
    14:              USE stomate_constants
    15:            
    16:              IMPLICIT NONE
    17:            
    18:              ! private & public routines
    19:            
    20:              PRIVATE
    21:              PUBLIC soilcarbon,soilcarbon_clear
    22:            
    23:                ! first call
    24:                LOGICAL, SAVE                                                     :: firstcall = .TRUE.
    25:            
    26:            CONTAINS
    27:            
    28:            
    29:              SUBROUTINE soilcarbon_clear
    30:                firstcall=.TRUE.
    31:              ENDSUBROUTINE soilcarbon_clear
    32:             
    33:              SUBROUTINE soilcarbon (npts, dt, clay, space_nat, &
    34:                                     soilcarbon_input, control_temp, control_moist, &
    35:                                     carbon, &
    36:                                     resp_hetero_soil)
    37:            
    38:                !
    39:                ! 0 declarations
    40:                !
    41:            
    42:                ! 0.1 input
    43:            
    44:                ! Domain size
    45:                INTEGER(i_std), INTENT(in)                                               :: npts
    46:                ! time step in days
    47:                REAL(r_std), INTENT(in)                                            :: dt
    48:                ! clay fraction (between 0 and 1)
    49:                REAL(r_std), DIMENSION(npts), INTENT(in)                           :: clay
    50:                ! total natural space (fraction of total space)
    51:                REAL(r_std), DIMENSION(npts), INTENT(in)                           :: space_nat
    52:                ! quantity of carbon going into carbon pools from litter decomposition
    53:                !   (gC/(m**2 of nat/agri ground)/day)
    54:                REAL(r_std), DIMENSION(npts,ncarb,nvegtypes), INTENT(in)           :: soilcarbon_input
    55:                ! temperature control of heterotrophic respiration
    56:                REAL(r_std), DIMENSION(npts,nlevs), INTENT(in)                     :: control_temp
    57:                ! moisture control of heterotrophic respiration
    58:                REAL(r_std), DIMENSION(npts,nlevs), INTENT(in)                     :: control_moist
    59:            
    60:                ! 0.2 modified fields
    61:            
    62:                ! carbon pool: active, slow, or passive, natural and agricultural (gC/m**2 of
    63:                !   natural or agricultural ground)
    64:                REAL(r_std), DIMENSION(npts,ncarb,nvegtypes), INTENT(inout)        :: carbon
    65:            
    66:                ! 0.3 output
    67:            
    68:                ! soil heterotrophic respiration (first in gC/day/m**2 of natural/agricultural ground,
    69:                !   but output in gC/day/m**2 of total ground)
    70:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(out)                :: resp_hetero_soil
    71:            
    72:                ! 0.4 local
    73:            
    74:                ! residence time in carbon pools (days)
    75:                REAL(r_std), SAVE, DIMENSION(ncarb)                                :: carbon_tau
    76:                ! flux fractions within carbon pools
    77:                REAL(r_std), DIMENSION(npts,ncarb,ncarb)                           :: frac_carb
    78:                ! fraction of carbon flux which goes into heterotrophic respiration
    79:                REAL(r_std), DIMENSION(npts,ncarb)                                 :: frac_resp
    80:                ! total flux out of carbon pools (gC/m**2)
    81:                REAL(r_std), DIMENSION(npts,ncarb)                                 :: fluxtot
    82:                ! fluxes between carbon pools (gC/m**2)
    83:                REAL(r_std), DIMENSION(npts,ncarb,ncarb)                           :: flux
    84:                ! for messages
    85:                CHARACTER*7, DIMENSION(ncarb)                                     :: carbon_str
    86:                ! Indices
    87:                INTEGER(i_std)                                                    :: k,kk,m
    88:            
    89:                ! =========================================================================
    90:            
    91:                IF (bavard.GE.3) WRITE(numout,*) 'Entering soilcarbon'
    92:            
    93:                !
    94:                ! 1 initializations
    95:                !
    96:            
    97:                !
    98:                ! 1.1 get soil "constants"
    99:                !
   100:            
   101:                ! 1.1.1 flux fractions between carbon pools: depend on clay content, recalculated
   102:                !       each time
   103:            
   104:                ! 1.1.1.1 from active pool: depends on clay content
   105:            
   106: V------>       frac_carb(:,iactive,iactive) = 0.0
   107: |              frac_carb(:,iactive,ipassive) = 0.004
   108: |              frac_carb(:,iactive,islow) = 1. - (.85-.68*clay(:)) - frac_carb(:,iactive,ipassive)
   109: |          
   110: |              ! 1.1.1.2 from slow pool
   111: |          
   112: |              frac_carb(:,islow,islow) = .0
   113: |              frac_carb(:,islow,iactive) = .42
   114: |              frac_carb(:,islow,ipassive) = .03
   115: |          
   116: |              ! 1.1.1.3 from passive pool
   117: |          
   118: |              frac_carb(:,ipassive,ipassive) = .0
   119: |              frac_carb(:,ipassive,iactive) = .45
   120: V------        frac_carb(:,ipassive,islow) = .0
   121:            
   122:            
   123:                IF ( firstcall ) THEN
   124:            
   125:                  ! 1.1.2 residence times in carbon pools (days)
   126:            
   127:                  carbon_tau(iactive) = .149 * one_year        !!!!???? 1.5 years
   128:                  carbon_tau(islow) = 5.48 * one_year          !!!!???? 25 years
   129:                  carbon_tau(ipassive) = 241. * one_year       !!!!???? 1000 years
   130:              
   131:                  !
   132:                  ! 1.2 messages
   133:                  !
   134:            
   135:                  carbon_str(iactive) = 'active'
   136:                  carbon_str(islow) = 'slow'
   137:                  carbon_str(ipassive) = 'passive'
   138:            
   139:                  WRITE(numout,*) 'soilcarbon:'
   140:            
   141:                  WRITE(numout,*) '   > minimal carbon residence time in carbon pools (d):'
   142: +------>         DO k = 1, ncarb
   143: |                  WRITE(numout,*) '       ',carbon_str(k),':',carbon_tau(k)
   144: +------          ENDDO
   145:            
   146:                  WRITE(numout,*) '   > flux fractions between carbon pools: depend on clay content'
   147:            
   148:                  firstcall = .FALSE.
   149:            
   150:                ENDIF
   151:            
   152:                !
   153:                ! 1.3 set output to zero
   154:                !
   155:            
   156: +V=====        resp_hetero_soil(:,:) = 0.0
   157:            
   158:                !
   159:                ! 2 input into carbon pools
   160:                !
   161:            
   162: ++V====        carbon(:,:,:) = carbon(:,:,:) + soilcarbon_input(:,:,:) * dt
   163:            
   164:                !
   165:                ! 3 fluxes within carbon reservoirs + respiration
   166:                !
   167:            
   168:                !
   169:                ! 3.1 determine fraction of flux that is respiration
   170:                !     diagonal elements of frac_carb are zero
   171:                !     VPP killer:
   172:                !     frac_resp(:,:) = 1. - SUM( frac_carb(:,:,:), DIM=3 )
   173:                !
   174:            
   175: +V=====        frac_resp(:,:) = 1. - frac_carb(:,:,iactive) - frac_carb(:,:,islow) - &
   176:                                 frac_carb(:,:,ipassive) 
   177:            
   178:                !
   179:                ! 3.2 calculate fluxes
   180:                !
   181:            
   182: +------>       DO m = 1, nvegtypes
   183: |          
   184: |                ! 3.2.1 flux out of pools
   185: |          
   186: |+----->         DO k = 1, ncarb
   187: ||         
   188: ||                 ! determine total flux out of pool
   189: ||         
   190: ||V====            fluxtot(:,k) = dt/carbon_tau(k) * carbon(:,k,m) * &
   191: ||                                control_moist(:,ibelow) * control_temp(:,ibelow)
   192: ||         
   193: ||                 IF ( k .EQ. iactive ) THEN
   194: ||V====              fluxtot(:,k) = fluxtot(:,k) * ( 1. - .75 * clay(:) )
   195: ||                 ENDIF
   196: ||         
   197: ||                 ! decrease this carbon pool
   198: ||         
   199: ||V====            carbon(:,k,m) = carbon(:,k,m) - fluxtot(:,k)
   200: ||         
   201: ||                 ! fluxes towards the other pools (k -> kk)
   202: ||         
   203: ||+---->           DO kk = 1, ncarb
   204: |||V===              flux(:,k,kk) = frac_carb(:,k,kk) * fluxtot(:,k)
   205: ||+----            ENDDO
   206: ||         
   207: |+-----          ENDDO
   208: |          
   209: |                ! 3.2.2 respiration
   210: |                !       VPP killer:
   211: |                !       resp_hetero_soil(:,m) = SUM( frac_resp(:,:) * fluxtot(:,:), DIM=2 ) / dt
   212: |          
   213: |V=====          resp_hetero_soil(:,m) = &
   214: |                     ( frac_resp(:,iactive) * fluxtot(:,iactive) + &
   215: |                       frac_resp(:,islow) * fluxtot(:,islow) + &
   216: |                       frac_resp(:,ipassive) * fluxtot(:,ipassive)  ) / dt
   217: |          
   218: |                ! 3.2.3 add fluxes to active, slow, and passive pools
   219: |                !       VPP killer:
   220: |                !       carbon(:,:,m) = carbon(:,:,m) + SUM( flux(:,:,:), DIM=2 )
   221: |          
   222: |+----->         DO k = 1, ncarb
   223: ||V====            carbon(:,k,m) = carbon(:,k,m) + &
   224: ||                                 flux(:,iactive,k) + flux(:,ipassive,k) + flux(:,islow,k)
   225: |+-----          ENDDO
   226: |          
   227: +------        ENDDO
   228:            
   229:                !
   230:                ! 4 transform respiration from gC/day/(m**2 of nat/agri ground) to
   231:                !   gC/day/(m**2 of total ground), as it goes into the atmosphere.
   232:                !
   233:            
   234: V------>       resp_hetero_soil(:,iagri) = resp_hetero_soil(:,iagri) * ( 1. - space_nat(:) )
   235: V------        resp_hetero_soil(:,inat) = resp_hetero_soil(:,inat) * ( space_nat(:) )
   236:            
   237:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving soilcarbon'
   238:            
   239:              END SUBROUTINE soilcarbon
   240:            
   241:            END MODULE stomate_soilcarbon
